=== debian/changelog ===
digikam (4:2.6.0~beta1-1) experimental; urgency=low

  * New upstream release

 -- Mark Purcell <msp@debian.org>  Thu, 09 Feb 2012 20:44:48 +1100
