=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with kde --parallel 

override_dh_auto_configure:
	LDFLAGS="$(LDFLAGS) -Wl,--as-needed" dh_auto_configure --buildsystem=kde

override_dh_installchangelogs:
	dh_installchangelogs core/ChangeLog 

# conflicts with oxygen-icon-theme package
override_dh_install:
	dh_install -Xmultithread -Xoxygen -XREADME.MACOSX --fail-missing

override_dh_strip:
	dh_strip -a --dbg-package=digikam-dbg
