=== debian/watch ===
version=3

opts=uversionmangle=s/-/~/  \
 http://sf.net/digikam/digikam-(\d+.*)\.tar\.bz2 debian svn-upgrade
